=== debian/control ===
Source: activiz.net
Section: graphics
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.3), mummy,
 libkitware-mummy-runtime1.0-cil, gccxml, libvtk5-dev (>= 5.6), mono-devel,
 cli-common-dev (>= 0.5.7), doxygen-latex (>= 1.6.2), graphviz
Standards-Version: 3.9.2
Homepage: http://www.kitware.com/products/avdownload.php
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/activiz.net/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/activiz.net/trunk/

Package: libactiviz.net5.6-cil
Architecture: any
Section: cli-mono
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}
Description: Tool for generating C# wrappers around VTK
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments. ActiViz, which generates C#
 wrappers around VTK, enables developers to combine the power of VTK with the
 many .NET framework objects for web and database access. Available as source
 code or as a pre-built WinForms Control, ActiViz .NET includes examples, online
 documentation, and supports IntelliSense in the .NET Framework

Package: activiz.net-doc
Architecture: all
Depends: ${misc:Depends}, doc-base
Suggests: vtk-doc
Section: doc
Description: ActiViz.NET documentation
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 .
 This package contains exhaustive HTML documentation for the all the
 documented ActiViz.NET C# classes.

Package: activiz.net-examples
Architecture: all
Suggests: vtk-examples
Section: graphics
Depends: ${misc:Depends}
Description: ActiViz.NET examples
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package contains examples from the ActiViz.NET source.
