=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS = \
	-DAVDN_INSTALL_PREFIX:PATH=/usr \
	-DAVDN_SNKEYFILE:STRING=/usr/share/cli-common/keys/mono.snk \
	-DAVDN_EXTRA_EXCLUDE_CLASSES:STRING="vtkMPIController;vtkMPICommunicator"

# B-D-I is still not quite right on buildd, but anyway let's be prepared:
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  CMAKE_FLAGS += -DGENERATE_DOXYGEN:BOOL=OFF
else
  CMAKE_FLAGS += -DGENERATE_DOXYGEN:BOOL=ON
endif

%:
	dh $@ --parallel --with cli

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

# dpkg-shlibdeps: error: no dependency information found for /usr/lib/libvtkNetCDF_cxx.so.5.6
override_dh_shlibdeps:
	dh_shlibdeps -- --ignore-missing-info

# Let's be smart with building doc
override_dh_auto_build-indep:
	$(MAKE) -C obj-* AVDN_doxygen

# No tests needed for docs
override_dh_auto_test-indep:

pkg_doc = activiz.net-doc
pkg_exa = activiz.net-examples

override_dh_install-indep:
	dh_install -p$(pkg_doc) obj-*/Doxygen/html usr/share/doc/$(pkg_doc)/
	find ./debian/$(pkg_doc)/usr/share/doc/$(pkg_doc)/html/ -name *.md5 -delete
	#dh_installexamples -p$(pkg_exa) usr/Examples/*
	dh_install -p$(pkg_exa) usr/Examples/*  usr/share/doc/$(pkg_exa)/examples
	find ./debian/$(pkg_exa) -name *.sln -delete

get-orig-source:
	./debian/get-orig-source
